<?php
namespace App\Http\Helpers;
/*

  DVLAClient.php v4
  (c) 2015 Mobunti Ltd
  No modification of this script is allowed by any  unauthorised person.
  Authorisation is provided by Mobunti Ltd.

*/

use Illuminate\Support\Facades\Log;

class DVLAClient{
    static private $alpha1;
    static private $num;
    static private $alpha2;
    static private $count;
    static private $perpage;
    static private $pagenum;
    static private $apikey;
    static private $order;
    static private $url = "http://www.registrationcentral.co.uk/api";
    static private $urltail;
    static public $response;
    static private $successful = false;

    static public function Init($key)
    {
        self::$apikey = $key;
    }
    static public function setFilter($alpha1,$num,$alpha2)
    {
        $empty=0;
        if (!$alpha1) {
            $alpha1="_";
            $empty++;
        }
        if (!$num) {
            $num = "___";
            $empty++;
        }
        if (!$alpha2)
        {
            $alpha2="___";
            $empty++;
        }

        self::$alpha1 = strtoupper($alpha1);
        self::$num = $num;
        self::$alpha2 = strtoupper($alpha2);
    }
    static public function setPageControl($pagenum,$perpage)
    {
        self::$pagenum = $pagenum;
        self::$perpage = $perpage;
    }
    static public function Count($group)
    {
        if (!self::$alpha1 && !self::$alpha2 && !self::$num) die("API Filter not provided");

        $alpha1 = self::$alpha1;
        $num = self::$num;
        $alpha2 = self::$alpha2;
        self::$urltail="/count/".$group."/".$alpha1."/".$num."/".$alpha2;
        $resp=self::Run();
        if (self::Successful()) return $resp->count;
        else return -1;
    }
    static public function Retrieve($group,$order)
    {
        if (!self::$alpha1 && !self::$alpha2 && !self::$num) die("API Filter not provided");

        $alpha1 = self::$alpha1;
        $num = self::$num;
        $alpha2 = self::$alpha2;
        $page = self::$pagenum;
        $perpage = self::$perpage;
        if ($group==="irish"){
            $alpha1 = self::$alpha2;
            $alpha2 = "___";
        }
        self::$urltail="/retrieve/".$group."/".$alpha1."/".$num."/".$alpha2."/".$page."/".$perpage."/".$order;
        $resp=self::Run();
        Log::debug(self::$urltail);
        Log::debug(print_r($resp,true));

        return $resp;
    }
    static public function Group($group,$letters)
    {
        if ($group != "prefix" && $group != "current" && $group != "irish") die("Group is not set correctly");
        if (strlen($letters)!=3) die("Group letters are not 3 long");
        self::$urltail="/group/$group/$letters";
        $resp=self::Run();
        return $resp;
    }
    static public function GetPrice($reg)
    {
        $reg=str_replace(" ","",$reg);
        self::$urltail="/getprice/".$reg;
        $resp=self::Run();
        return $resp;
    }

    static public function Successful()
    {
        return self::$successful;
    }
    static private function Run()
    {
        if (!self::$apikey) die("API Key not set");
        self::$successful = false;
        $ch = curl_init();
        $header=array("X-Auth-Token: ".self::$apikey);
        curl_setopt($ch, CURLOPT_URL,self::$url.self::$urltail);
        curl_setopt($ch, CURLOPT_HTTPHEADER,$header);
        curl_setopt($ch, CURLOPT_POST, false);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
        curl_setopt($ch, CURLOPT_VERBOSE, 1);
        curl_setopt($ch, CURLOPT_HEADER, 1);
curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        $response = curl_exec ($ch);
        $error_msg = "";
        if (curl_errno($ch)) 
           $error_msg = curl_error($ch);
        $header_size = curl_getinfo($ch, CURLINFO_HEADER_SIZE);
        $header = substr($response, 0, $header_size);
        $body = substr($response, $header_size);
        $json=json_decode($body);
        if ($json) self::$successful = true;
        self::$response = $json;
        \Log::info(print_r($response,true));
        \Log::info(print_r($error_msg,true));
        //mail("tonyb@mobunti.co.uk","acereg",self::$url.self::$urltail."\n\n".$response);
        return $json;
    }
}
