<?php
/**
 * Project AceReg.
 * User: tony
 * Date: 26/05/2021
 * Time: 11:52
 */

namespace App\Http\Helpers;


use Statamic\Facades\Term;

class VRN
{
    protected string $primaryAlpha="";
    protected string $alpha1="";
    protected string $numbers="";
    protected string $alpha2="";
    protected string $format="";
    protected string $mask="";
    protected bool $is3x3=false;
    protected bool $is3x2=false;
    protected bool $is3x1=false;
    protected string $noSpace="";
    protected string $vrn="";
    protected string $formattedVRN="";
    protected string $error="";
    protected string $dateIssued="";
    protected $prefixReleases=[
        "A"=>"1st August 1983",
        "B"=>"1st August 1984",
        "C"=>"1st August 1985",
        "D"=>"1st August 1986",
        "E"=>"1st August 1987",
        "F"=>"1st August 1988",
        "G"=>"1st August 1989",
        "H"=>"1st August 1990",
        "J"=>"1st August 1991",
        "K"=>"1st August 1992",
        "L"=>"1st August 1993",
        "M"=>"1st August 1994",
        "N"=>"1st August 1995",
        "P"=>"1st August 1996",
        "R"=>"1st August 1997",
        "S"=>"1st August 1998",
        "T"=>"1st March 1999",
        "V"=>"1st September 1999",
        "W"=>"1st March 2000",
        "X"=>"1st September 2000",
        "Y"=>"1st March 2001",

    ];
    protected $suffixReleases=[
        "A"=>"1963",
        "B"=>"1964",
        "C"=>"1965",
        "D"=>"1966",
        "E"=>"1967",
        "F"=>"1967",
        "G"=>"1968",
        "H"=>"1969",
        "J"=>"1970",
        "K"=>"1971",
        "L"=>"1972",
        "M"=>"1973",
        "N"=>"1974",
        "P"=>"1975",
        "R"=>"1976",
        "S"=>"1977",
        "T"=>"1978",
        "V"=>"1979",
        "W"=>"1980",
        "X"=>"1981",
        "Y"=>"1982",

    ];
    protected $currentReleases=[
        "51"=>"1st September 2001",
        "02"=>"1st March 2002",
        "52"=>"1st September 2002",
        "03"=>"1st March 2003",
        "53"=>"1st September 2003",
        "04"=>"1st March 2004",
        "54"=>"1st September 2004",
        "05"=>"1st March 2005",
        "55"=>"1st September 2005",
        "06"=>"1st March 2006",
        "56"=>"1st September 2006",
        "07"=>"1st March 2007",
        "57"=>"1st September 2007",
        "08"=>"1st March 2008",
        "58"=>"1st September 2008",
        "09"=>"1st March 2009",
        "59"=>"1st September 2009",
        "10"=>"1st March 2010",
        "60"=>"1st September 2010",
        "11"=>"1st March 2011",
        "61"=>"1st September 2011",
        "12"=>"1st March 2012",
        "62"=>"1st September 2012",
        "13"=>"1st March 2012",
        "63"=>"1st September 2012",
        "14"=>"1st March 2014",
        "64"=>"1st September 2014",
        "15"=>"1st March 2015",
        "65"=>"1st September 2015",
        "16"=>"1st March 2016",
        "66"=>"1st September 2016",
        "17"=>"1st March 2017",
        "67"=>"1st September 2017",
        "18"=>"1st March 2018",
        "68"=>"1st September 2018",
        "19"=>"1st March 2019",
        "69"=>"1st September 2019",
        "20"=>"1st March 2010",
        "70"=>"1st September 2020",
        "21"=>"1st March 2021",
        "71"=>"1st September 2021",
        "22"=>"1st March 2022",
        "72"=>"1st September 2022",
        "23"=>"1st March 2023",
        "73"=>"1st September 2023",
        "24"=>"1st March 2024",
        "74"=>"1st September 2024",
        "25"=>"1st March 2025",
        "75"=>"1st September 2025",
        "26"=>"1st March 2026",
        "76"=>"1st September 2026",
        "27"=>"1st March 2027",
        "77"=>"1st September 2027",
        "28"=>"1st March 2028",
        "78"=>"1st September 2028",
        "29"=>"1st March 2029",
        "79"=>"1st September 2029",
        "30"=>"1st March 2030",
        "80"=>"1st September 2030",
        ];

    /**
     * @return string
     */
    public function getPrimaryAlpha(): string
    {
        return $this->primaryAlpha;
    }

    /**
     * @return string
     */
    public function getAlpha1(): string
    {
        return $this->alpha1;
    }

    /**
     * @return string
     */
    public function getNumbers(): string
    {
        return $this->numbers;
    }

    /**
     * @return string
     */
    public function getAlpha2(): string
    {
        return $this->alpha2;
    }

    /**
     * @return string
     */
    public function getFormat(): string
    {
        return $this->format;
    }

    /**
     * @return string
     */
    public function getMask(): string
    {
        return $this->mask;
    }

    /**
     * @return string
     */
    public function getIs3x3(): bool
    {
        return $this->is3x3;
    }
    public function getIs3x2(): bool
    {
        return $this->is3x2;
    }
    public function getIs3x1(): bool
    {
        return $this->is3x1;
    }

    /**
     * @return string
     */
    public function getNoSpace(): string
    {
        return $this->noSpace;
    }

    public function addOrUpdateTag(string $slug, string $title, string $taxonomy, string $content)
    {
        if (!$slug) return;
        $tax=Term::findBySlug($slug,$taxonomy);
        if (!$tax){
            Term::make($slug)
                ->taxonomy($taxonomy)
                ->set('title', $title)
                ->set("content",$content)
                ->save();
        }
        else{
            $tax->set("title",$title);
            $tax->set("content",$content);
            $tax->save();
        }

    }
    /**
     * VRN constructor.
     * @param string $vrn
     */
    public function __construct(string $vrn)
    {
        $vrn=strtoupper($vrn);
        $this->vrn = $vrn;
        $this->noSpace=str_replace(" ","",$vrn);
        $this->mask="";
        $length=strlen($this->noSpace);
        $pos=0;
        $this->numbers="";
        $alphas="";
        $alpha1Chunk="";
        $alpha2Chunk="";
        while($pos<$length){
            $char=substr($this->noSpace,$pos,1);
            if($char>="A" && $char<="Z") {
                $this->mask.="A";
                $alphas .= $char; // used to identify broken vrns such as when searching
                if (!$this->numbers) $alpha1Chunk .= $char;
                else $alpha2Chunk .= $char;
            }
            if($char>="0" && $char<="9") {
                $this->mask.="N";
                $this->numbers .= $char;
            }
            $pos++;
        }
        if (!$this->numbers){
            // it was a registration without any numbers
            $this->alpha1=$this->noSpace;
            $this->error = "Invalid registration. No numbers provided";
            return;
        }
        if (!$alphas){
            // it was a registration without any alphas
            $this->numbers=$this->noSpace;
            $this->error = "Invalid registration. No alphas provided";
            return;
        }
        if ($this->mask==="ANNNAAA" || $this->mask==="ANNAAA" || $this->mask==="ANAAA"){
            $this->format="PREFIX";
            $this->alpha1=substr($this->noSpace,0,1);
            $this->alpha2=substr($this->noSpace,-3);
            $this->primaryAlpha = $this->alpha2;
            $this->formattedVRN=$this->alpha1.$this->numbers." ".$this->alpha2;
            if (array_key_exists($this->alpha1,$this->prefixReleases))
                $this->dateIssued = $this->prefixReleases[$this->alpha1];
            else
                $this->error = "Identified {$this->vrn} as a prefix but ".$this->alpha1." not found in valid list";
        }
        elseif ($this->mask==="AAANNNA" || $this->mask==="AAANNA" || $this->mask==="AAANA"){
            $this->format="SUFFIX";
            $this->alpha1=substr($this->noSpace,0,3);
            $this->alpha2=substr($this->noSpace,-1);
            $this->primaryAlpha = $this->alpha1;
            $this->formattedVRN=$this->alpha1." ".$this->numbers.$this->alpha2;
            if (array_key_exists($this->alpha2,$this->suffixReleases))
                $this->dateIssued = $this->suffixReleases[$this->alpha2];
            else
                $this->error = "Identified {$this->vrn} as a suffix but ".$this->alpha2." not found in valid list";
        }
        elseif ($this->mask==="AANNAAA"){
            $this->format="CURRENT";
            $this->alpha1=substr($this->noSpace,0,2);
            $this->alpha2=substr($this->noSpace,-3);
            $this->primaryAlpha = $this->alpha2;
            $this->formattedVRN=$this->alpha1.$this->numbers." ".$this->alpha2;
            if (array_key_exists($this->numbers,$this->currentReleases))
                $this->dateIssued = $this->currentReleases[$this->numbers];
            else
                $this->error = "Identified {$this->vrn} as a current style but ".$this->numbers." not found in valid list";
        }
        else {
            if ($this->noSpace===$alphas.$this->numbers){
                $this->formattedVRN=$alphas." ".$this->numbers;
                $this->format="DATELESS";
                $this->alpha1 = $alphas;
                $this->alpha2 = "";
                $this->primaryAlpha = $this->alpha1;
            }
            if ($this->noSpace===$this->numbers.$alphas){
                $this->formattedVRN=$this->numbers." ".$alphas;
                $this->format="DATELESS";
                $this->alpha1 = "";
                $this->alpha2 = $alphas;
                $this->primaryAlpha = $this->alpha2;
            }
            if ($this->format=="DATELESS") {
                if (strpos($this->noSpace, "I") !== false || strpos($this->noSpace, "Z") !== false) {
                    $this->format = "IRISH";
                }
                if (strlen($alphas) === 3 && strlen($this->numbers) === 3 ) {
                    $this->is3x3 = true;
                } else {
                    $this->is3x3 = false;
                }
                if (strlen($alphas) === 3 && strlen($this->numbers) === 2 ) {
                    $this->is3x2 = true;
                } else {
                    $this->is3x2 = false;
                }
                if (strlen($alphas) === 3 && strlen($this->numbers) === 1 ) {
                    $this->is3x1 = true;
                } else {
                    $this->is3x1 = false;
                }
            }
            else{
                $this->error="Registration does not seem to be dateless and does not match other formats: $vrn";
            }
            if (strlen($this->numbers) < 1 || strlen($this->numbers) >4)
                $this->error="Invalid quantity of numerics: $vrn";
            if (strlen($this->primaryAlpha) < 1 || strlen($this->primaryAlpha) >3)
                $this->error="Invalid alpha length: $vrn";
        }
        if (!$this->format) {
            // not a valid format but we try and store as much as we can because this class is used for searching too
            // so if we can store A 31 AB we can search but we know from the error its not valid
            $this->alpha1 = $alpha1Chunk;
            $this->alpha2 = $alpha2Chunk;
            $this->primaryAlpha = strlen($alpha1Chunk)>strlen($alpha2Chunk)?$alpha1Chunk:$alpha2Chunk;
            $this->error = "Could not identify format of ".$this->vrn;
        }
    }

    /**
     * @return string
     */
    public function getError(): string
    {
        return $this->error;
    }

    /**
     * @return string
     */
    public function getDateIssued(): string
    {
        return $this->dateIssued;
    }

    /**
     * @return string
     */
    public function getVrn(): string
    {
        return $this->formattedVRN;
    }
}
