<?php

namespace App\Http\Livewire;

use App\Mail\ContactMail;
use Illuminate\Support\Facades\Mail;
use Livewire\Component;

class ContactForm extends Component
{
    public $fullName;
    public $email;
    public $message;
    public $response;

    protected $validationAttributes = [
      "email" => "email address",
      "fullName" => "name",
      "message" => "question",
    ];
    protected $rules = [
      "email" => "email|required",
      "fullName" => "required",
      "message" => "required"
    ];

    public function render()
    {
        return view('livewire.contact-form');
    }

    public function send()
    {
        $this->validate();
        Mail::to([config("app.enquiry_email_name")=>config("app.enquiry_email")])
            ->send(new ContactMail($this->fullName,$this->email,$this->message));
        $this->response="Many thanks. Your request has been sent. We will be in touch soon";
        $this->message = "";
        $this->fullName = "";
        $this->email = "";
    }
}
