<?php

namespace App\Http\Livewire;

use App\Jobs\ProcessImport;
use Livewire\Component;
use Livewire\TemporaryUploadedFile;
use Livewire\WithFileUploads;
use Statamic\Facades\Entry;

class UploadDealerFile extends Component
{
    use WithFileUploads;

    public string $dealer="ACEREG";
    public array $dealers=[];
    public string $addVAT="Y";
    public string $markupType="percentage";
    public string $percentage="20";
    public string $flatRate="50";
    public string $stockType="STOCK";
    public  $upload=null;
    public bool $processing = false;
    public $totalInFile = 0;
    public $totalProcessed = 0;

    protected $rules = [
        'upload' => 'required|mimes:csv|max:20480',
        'flatRate' => 'required_if:markupType,=,"flatrate"|numeric|nullable',
        'percentage' => 'required_if:markupType,=,"percentage"|numeric|nullable',
    ];
    public function render()
    {
        $dealerCollection = Entry::query()
            ->where('collection', 'suppliers')
            ->get();
        foreach($dealerCollection as $entry){
            $items = $entry->data();
            $this->dealers[$entry->slug()] = $items["title"];
        }
        return view('livewire.upload-dealer-file');
    }

    public function save() {
        $this->validate();
        if ($this->upload){
            $file = $this->upload->store('csv', 'local');
            $filePath = storage_path("app/".$file);
            $fp=fopen($filePath."-info","w");
            $csv=[$this->dealer,$this->addVAT,$this->markupType,$this->markupType=="percentage"?$this->percentage:$this->flatRate,$this->stockType];
            fputcsv($fp,$csv);
            fclose($fp);
            //dd($file);
            //dd(file(storage_path("app/".$file)));
            $this->processing = true;
            ProcessImport::dispatch($filePath);
        }

    }
}
